function d_m = MeasureofDirection(img,w)

img_cmp = padarray(img,[(w-1)/2 (w-1)/2],'symmetric');

[r c] = size(img_cmp);

hx = [-1 -2 -1;0 0 0;1 2 1];
hy = hx';

gradx = filter2(hx,img_cmp,'same');
grady = abs(filter2(hy,img_cmp,'same'));

theta = atan2(grady,gradx);

bw = edge(img_cmp,'canny',0.1);
theta = theta.*bw;

for i = 1 + (w-1)/2 : r - (w-1)/2
   for j = 1 + (w-1)/2 : c - (w-1)/2
       temp = theta(i-(w-1)/2:i+(w-1)/2,j-(w-1)/2:j+(w-1)/2);
       d_m(i-(w-1)/2,j-(w-1)/2) = direction_measure(temp);
   end
end
            


function mofd = direction_measure(x)

[m n] = size(x);
angle_ave = sum(sum(x))/(m*n);

mofd = angle_ave/(pi/2);

% [m n] = size(x);
% sum_h = 0;
% sum_v = 0;
% for j = 1 : n
%     for i = 1 : m-1
%         sum_h = sum_h + abs(x(i+1,j) - x(i,j));
%     end
% end
% 
% for i = 1 : m
%     for j = 1 : n-1
%         sum_v = sum_v + abs(x(i,j+1) - x(i,j));
%     end
% end
% 
% if strcmp(dir,'vertical')
%     if sum_v == 0 && sum_h == 0
%         mofd = 0;
%     else
%         mofd = (sum_v+1e-10)/(sum_h+1e-10);
%     end
% else
%     if sum_v == 0 && sum_h == 0
%         mofd = 0;
%     else
%         mofd = (sum_h+1e-10)/(sum_v+1e-10);
%     end
% end