function d_m = MeasureofLinelikeness(img,w)

img_cmp = padarray(img,[w w],'symmetric');

[r, c] = size(img);
d_m = zeros(r,c);

hx = [-1 -2 -1;0 0 0;1 2 1];
hy = hx';

gradx = abs(filter2(hx,img_cmp,'same'));
grady = abs(filter2(hy,img_cmp,'same'));

theta1 = atan2(grady,gradx);
bw = edge(img_cmp,'canny');
theta = theta1.*bw;

% theta(theta<=pi/8)=0;
% theta(theta>pi/8 & theta<=3*pi/8) = pi/4;
% theta(theta>3*pi/8) = pi/2;

for i = 1+w:r+w
    for j = 1+w:c+w
        temp = theta(i-w:i+w,j-w:j+w);

        d_m(i-w,j-w) = 1-std(temp(:))/(pi/4);
    end
end