close all;
clear;
clc;
I = im2double(imread('test_decomp_15.png'));
% [r,c] = size(I);

%% Enhance the input image by the proposed textural difference enhancing method
T = TMCA_ENHANCEMENT(I);

D = T-I;%compute the difference between the input image and the manipulated image.

figure(5);imshow(I);
f1 = getframe(gcf);
figure(6);imshow(T);
f2 = getframe(gcf);
figure(7);imagesc(D);axis off;colorbar;
f3 = getframe(gcf);

close 5;close 6;close 7;
figure;%create new figure.
subplot(2,2,1),imshow(f1.cdata),title({'Input';'texture image'});
subplot(2,2,2),imshow(f2.cdata),title({'Manipulated';'texture image'});
subplot(2,2,[3,4]),imshow(f3.cdata);title({'The difference';'between input';'and manipulated images'});
%% Test the segmentation by different texture-based segmentation methods, compared with image enhancement methods.

%Manipulation by unsharp filter

fprintf('Manipulating the image by unsharp filter...\n');

T1 = imfilter(I,fspecial('unsharp'),'symmetric');

%Manipulation by VISUShrink method

fprintf('Manipulating the image by VISUShrink filter...\n');

T2 = NeighShrinkSUREdenoise(I, 3, 'sym4', 3);

%Manipulation by coherence-enhancing diffusion filter

fprintf('Manipulating the image by Coherence-enhance diffusion filter...\n');

T3 = CoherenceFilter(I);

%Manipulation by shock filter

fprintf('Manipulating the image by shock filter...\n');

T4 = shock(I,100);

%Segmentation by Thresholding Segmentation, K-Means Segmentation,
%Mean-shift Segmentation and GMM Segmentation respectively.

fprintf('Segmenting the enhanced images...\n');

[img_bs2,img_bs3,img_bs4,img_c2,img_c3,img_c4] = demo_segment(I);

[t_bs2,t_bs3,t_bs4,t_c2,t_c3,t_c4] = demo_segment(T);

[t1_bs2,t1_bs3,t1_bs4,t1_c2,t1_c3,t1_c4] = demo_segment(T1);

[t2_bs2,t2_bs3,t2_bs4,t2_c2,t2_c3,t2_c4] = demo_segment(T2);

[t3_bs2,t3_bs3,t3_bs4,t3_c2,t3_c3,t3_c4] = demo_segment(T3);

[t4_bs2,t4_bs3,t4_bs4,t4_c2,t4_c3,t4_c4] = demo_segment(T4);

%Show the comparing segmentation results.
fprintf('Showing the segmentation results...\n');
figure;
subplot(4,6,1),imshow(I),xlabel('Original');
subplot(4,6,7),imshow(img_bs2),xlabel(['c=', num2str(img_c2*100),'%']);
subplot(4,6,13),imshow(img_bs3),xlabel(['c=', num2str(img_c3*100),'%']);
subplot(4,6,19),imshow(img_bs4),xlabel(['c=', num2str(img_c4*100),'%']);
subplot(4,6,2),imshow(T1),xlabel('UM');
subplot(4,6,8),imshow(t1_bs2),xlabel(['c=', num2str(t1_c2*100),'%']);
subplot(4,6,14),imshow(t1_bs3),xlabel(['c=', num2str(t1_c3*100),'%']);
subplot(4,6,20),imshow(t1_bs4),xlabel(['c=', num2str(t1_c4*100),'%']);
subplot(4,6,3),imshow(T2),xlabel('VISU');
subplot(4,6,9),imshow(t2_bs2),xlabel(['c=', num2str(t2_c2*100),'%']);
subplot(4,6,15),imshow(t2_bs3),xlabel(['c=', num2str(t2_c3*100),'%']);
subplot(4,6,21),imshow(t2_bs4),xlabel(['c=', num2str(t2_c4*100),'%']);
subplot(4,6,4),imshow(T3),xlabel('CDF');
subplot(4,6,10),imshow(t3_bs2),xlabel(['c=', num2str(t3_c2*100),'%']);
subplot(4,6,16),imshow(t3_bs3),xlabel(['c=', num2str(t3_c3*100),'%']);
subplot(4,6,22),imshow(t3_bs4),xlabel(['c=', num2str(t3_c4*100),'%']);
subplot(4,6,5),imshow(T4),xlabel('SHK');
subplot(4,6,11),imshow(t4_bs2),xlabel(['c=', num2str(t4_c2*100),'%']);
subplot(4,6,17),imshow(t4_bs3),xlabel(['c=', num2str(t4_c3*100),'%']);
subplot(4,6,23),imshow(t4_bs4),xlabel(['c=', num2str(t4_c4*100),'%']);
subplot(4,6,6),imshow(T),xlabel('TC-MCA');
subplot(4,6,12),imshow(t_bs2),xlabel(['c=', num2str(t_c2*100),'%']);
subplot(4,6,18),imshow(t_bs3),xlabel(['c=', num2str(t_c3*100),'%']);
subplot(4,6,24),imshow(t_bs4),xlabel(['c=', num2str(t_c4*100),'%']);
ax = axes('position',[0,0,1,1],'visible','off');
tx = text(0.15,0.05,'Segmentation of texture images manipulated by different methods');
set(tx,'fontweight','bold');
tx2 = text(0.91,0.65,['K-me-',char(10),'ans']);
set(tx2,'fontweight','bold');
tx3 = text(0.91,0.43,['Mean-',char(10),'shift']);
set(tx3,'fontweight','bold');
tx4 = text(0.91,0.21,'GMM');
set(tx4,'fontweight','bold');



